#define SCALER 250

unsigned char	count[1];
void  timerb_isr();

void main()
{

	WrPortI(PEFR,&PEFRShadow,0);
	WrPortI(PEDDR,&PEDDRShadow,0x82);
	WrPortI(PECR,&PECRShadow,0);
	WrPortI(PEDR,&PEDRShadow,0x80); 		/* prende un LED y apaga el otro */

	SetVectIntern(0x0B, timerb_isr);	   // setea vector de interrupcin

	WrPortI(TBCR, &TBCRShadow, 0x09);	// clock timer B con (perclk/16)
													// prioridad de interrupcin: 1

	WrPortI(TBL1R, NULL, 0x00);			// el timer interrumpe cuando
	WrPortI(TBM1R, NULL, 0x00);			// el contador llega a 0000

   count[0]=SCALER;							// inicializa postscaler

	WrPortI(TBCSR, &TBCSRShadow, 0x03);	// habilita timer B e interrupcin por match en B1

   while(1);

}



#asm
timerb_isr::
	push	af							; salva registros
	ioi	ld a, (TBCSR)			; reconoce interrupcin
	xor a
	ioi	ld (TBL1R), a			; siguiente: timer=0000h (otra vez)
	ioi	ld (TBM1R), a
   ld a,(count)					; postscaler
   dec a								; decrementa postscaler
   jr nz,skip						; si no llega a cero, saltea
   ld a,SCALER						; lleg a cero, recarga postcaler
skip:
   ld (count),a					; carga el valor decrementado o la recarga
   jr nz,chau						; si no lleg a cero (antes), sale

	ioi 	ld a,(PEDR)				; lee port E
	xor 	0x82						; invierte bits de LEDs (destello alternado)
	ioi 	ld (PEDR), a			; escribe port E
chau:
	pop	af							; recupera registros
	ipres								; restablece interrupciones
	ret								; retorna
#endasm