#class auto
// Define tamao de buffers (2^n-1)
/* Estos ejemplos usan port A en vez de port B como en el libro, a fin de
permitir su rpido chequeo utilizando el mismo cable que para programacin
(consultar en el manual del core module la forma de conexin el cable,
en caso de ser necesario)
*/

#define AINBUFSIZE  15
#define AOUTBUFSIZE 15
// Timeout de funcin (10 segs desde el ltimo caracter recibido)
#define MSSG_TMOUT 10000UL
// Timeout de programa (30 segundos sin recibir nada)
#define IDLE_TMOUT 30000UL

#define MAX_SENTENCE 20


void main()
{
unsigned long t;
unsigned char replydata[256], sentence[MAX_SENTENCE+1];
int input_char;
int string_pos;

   string_pos = 0;
	WrPortI ( SPCR, &SPCRShadow, 0x84 );		// PA0-7 = Outputs
	serAopen(1200);
	loopinit();
	for (;;) {
	   loophead();
		costate {
    		 t = MS_TIMER;
			 wfd input_char = cof_serAgetc();
		    if(input_char == '\r' || input_char == '\n') {
				// procesa el paquete
            	sentence[string_pos]=0;
	    			sprintf(replydata,"\r\nRx: %s\r\n",sentence);
					wfd cof_serAwrite(replydata, strlen(replydata)); // mensaje
				   string_pos = 0;
	   	 }
		    else {
				sentence[string_pos] = input_char;
				string_pos++;
				if(string_pos == MAX_SENTENCE){
		   	 // accin si excede tamao de buffer
            	sentence[string_pos]=0;
      	      string_pos=0;
	    			sprintf(replydata,"\r\n>> Buffer excedido: %s\r\n",sentence);
					wfd cof_serAwrite(replydata, strlen(replydata)); // mensaje
		      }
          }
		}
	    costate {					// Rx timeout
    		if (MS_TIMER > t + IDLE_TMOUT){
    			t = MS_TIMER;
    			sprintf(replydata,"\r\n>> Inactivo\r\n");
				wfd cof_serAwrite(replydata, strlen(replydata)); // mensaje
    		}
	    }
	    costate {					// Tarea ficticia
			waitfor(DelayMs(100));
			BitWrPortI( PADR, &PADRShadow, (PADRShadow&1)^1, 0); // toggle LED 2
	    }
	}
	while (serAwrFree() != AOUTBUFSIZE);		// espera vaciar buffer de Tx
	serAclose();					// cierra port
}

